"{ Package: 'stx:libbasic3' }"!

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerAllowEditOfHistory
    "useful if you have 'beginner students', to prevent them from changing the history"

    ^self 
        at: #'history-manager.allow-edit-of-history'
        ifAbsentPut:false

    "Modified (Format): / 30-06-2011 / 17:07:33 / cg"
    "Modified (Comment): / 30-06-2011 / 17:09:24 / cg"
! !

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerModificationLimit
    "the time-delta within which the history manager does not treat a change as a new one"

    ^self 
        at: #'history-manager.modification-limit'
        ifAbsentPut: 3600 "/one hour"

    "Created: / 04-10-2008 / 11:55:56 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified (Comment): / 30-06-2011 / 17:25:09 / cg"
! !

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerModificationLimit: sec
    "the time-delta within which the history manager does not treat a change as a new one"

    ^self 
        at: #'history-manager.modification-limit'
        put: sec

    "Created: / 04-10-2008 / 11:56:23 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified (Comment): / 30-06-2011 / 17:25:13 / cg"
! !

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerSignature
    "the signature added by the history manager"

    ^self historyManagerSignatures
        at: (Array with: OperatingSystem getHostName with: OperatingSystem getLoginName)
        ifAbsent: [OperatingSystem getLoginName]

    "Created: / 04-10-2008 / 12:06:58 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 08-07-2011 / 10:24:48 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 04-08-2011 / 17:24:21 / cg"
! !

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerSignature: aString
    "the signature added by the history manager"

    ^self historyManagerSignatures
        at: (Array with: OperatingSystem getHostName with: OperatingSystem getLoginName)
        put: aString

    "Created: / 04-10-2008 / 11:54:53 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified (Comment): / 30-06-2011 / 17:25:31 / cg"
! !

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerSignatures
    "the signatures added by the history manager"

    ^self 
        at: #'history-manager.signatures'
        ifAbsentPut: [Dictionary new]

    "
     UserPreferences current historyManagerSignatures
    "

    "Created: / 04-10-2008 / 11:52:40 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 22-08-2009 / 11:00:12 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified (Comment): / 30-06-2011 / 17:27:14 / cg"
! !

!UserPreferences methodsFor:'accessing - history manager'!

historyManagerSignatures: aDictionary
    "the signatures added by the history manager"

    ^self 
        at: #'history-manager.signatures'
        ifAbsentPut: aDictionary

    "Created: / 04-10-2008 / 11:52:58 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified (Comment): / 30-06-2011 / 17:26:48 / cg"
! !

!UserPreferences methodsFor:'accessing-source code management'!

managerPerMatchingModuleDefinitions

    | defs |

    defs := (self at: #'managerPerMatchingModuleDefinitionsKey' ifAbsent:[#()]).
    ^(defs collect:[:e|e decodeAsLiteralArray]) asOrderedCollection

    "
        UserPreferences current managerPerMatchingModuleDefinitions
        UserPreferences current managerPerMatchingModuleDefinitions: #().
    "

    "Created: / 09-07-2011 / 13:33:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!UserPreferences methodsFor:'accessing-source code management'!

managerPerMatchingModuleDefinitions: defs

    self at: #'managerPerMatchingModuleDefinitionsKey' 
        put: (defs collect:[:e| e literalArrayEncoding]) asArray.
    AbstractSourceCodeManager managerPerMatchingModuleDefinitions == defs ifFalse:[
        AbstractSourceCodeManager managerPerMatchingModuleDefinitions: defs.
    ]

    "Created: / 09-07-2011 / 13:35:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!stx_libbasic3 class methodsFor:'documentation'!

extensionsVersion_CVS
    ^ '$Header: /cvs/stx/stx/libbasic3/extensions.st,v 1.11 2011-08-04 19:38:21 cg Exp $'
! !